<template>
    <div class="wrapper">
        <loading :active.sync="loading" is-full-page></loading>
        <nav-title :title="title" :icon="icon"></nav-title>
        <div class="md-layout  mt-3">
            <div class="md-layout-item md-xlarge-size-20 md-large-size-20 md-medium-size-90 md-small-size-95"></div>
            <div class="md-layout-item  md-xlarge-size-30 md-large-size-40 md-medium-size-90 md-small-size-95">
                <md-card>
                    <div class="md-layout md-alignment-top-center">
                        <div class="md-layout-item text-align-center  mt-2">
                            <md-avatar class="md-avatar-icon md-large avatar-cuenta">
                                <img class="img-profile " :src="Profile.image_path" alt="Perfil" />
                            </md-avatar>
                        </div>
                    </div>

                    <md-card-area>
                        <md-card-content>
                            <section name="Begin">
                                <h3 class="md-title text-red">
                                    <b>{{ personalInfo.fullname ? personalInfo.fullname : user.username }}</b>
                                </h3>
                                <hr class="line" />
                                <md-list class="">
                                    <md-list-item class="md-list-item-content-pl md-list-item-content">
                                        <div class="md-list-item-text md-body-1">
                                            <h4 class="text-red">
                                                COLABORADOR
                                            </h4>
                                        </div>
                                    </md-list-item>
                                    <md-divider class="t"></md-divider>
                                    <md-list-item class="md-list-item-content-pl md-list-item-content">
                                        <div class="md-list-item-text md-body-1">
                                            <h4>
                                                {{ country }}
                                            </h4>
                                        </div>
                                    </md-list-item>
                                </md-list>
                                <md-button
                                    class="md-raised md-primary "
                                    :to="{
                                        name: 'author',
                                        params: { id: user.id }
                                    }"
                                    >Ver perfil publico</md-button
                                >
                            </section>

                            <section class="mt-2" name="PersonalData">
                                <h4 class="text-red no-margin">
                                    DATOS PERSONALES
                                </h4>
                                <hr class="line" />
                                <md-field>
                                    <label>Nombre</label>
                                    <md-input v-model="personalInfo.fullname"></md-input>
                                </md-field>
                                <label>Fecha de nacimiento</label>
                                <md-field>
                                    <md-input v-model="personalInfo.birthdate" type="date"></md-input>
                                    <!-- <md-datepicker  v-model="date" >
                                    </md-datepicker> -->
                                </md-field>
                                <md-field>
                                    <label>País</label>
                                    <md-select v-model="personalInfo.country_id" name="country" id="country">
                                        <md-option v-for="countrie in countries" :key="countrie.id" :value="countrie.id">{{
                                            countrie.name
                                        }}</md-option>
                                    </md-select>
                                </md-field>
                                <md-field>
                                    <label>Sexo</label>
                                    <md-select v-model="personalInfo.gender" name="gender" id="gender">
                                        <md-option value="Hombre">Hombre</md-option>
                                        <md-option value="Mujer">Mujer</md-option>
                                    </md-select>
                                </md-field>
                                <md-field>
                                    <label>Descripción</label>
                                    <md-textarea v-model="personalInfo.description"></md-textarea>
                                </md-field>
                                <!-- <md-field>
                                    <label>Facebook</label>
                                    <md-input
                                        type="url"
                                        v-model="personalInfo.social_facebook"
                                    ></md-input>
                                    <span class="md-helper-text"
                                        >Ingrese una URL</span
                                    >
                                </md-field>
                                <md-field>
                                    <label>Twitter</label>
                                    <md-input
                                        type="url"
                                        v-model="personalInfo.social_twitter"
                                    ></md-input>
                                    <span class="md-helper-text"
                                        >Ingrese una URL</span
                                    >
                                </md-field>
                                <md-field>
                                    <label>Youtube</label>
                                    <md-input
                                        type="url"
                                        v-model="personalInfo.social_youtube"
                                    ></md-input>
                                    <span class="md-helper-text"
                                        >Ingrese una URL</span
                                    >
                                </md-field>
                                <md-field>
                                    <label>Instagram</label>
                                    <md-input
                                        type="url"
                                        v-model="personalInfo.social_instagram"
                                    ></md-input>
                                    <span class="md-helper-text"
                                        >Ingrese una URL</span
                                    >
                                </md-field>
                                <md-field>
                                    <label>Snapchat</label>
                                    <md-input
                                        type="url"
                                        v-model="personalInfo.social_snapcha"
                                    ></md-input>
                                    <span class="md-helper-text"
                                        >Ingrese una URL</span
                                    >
                                </md-field> -->

                                <md-button class="md-raised md-primary" @click="SavePersonalInfo">Guardar cambio</md-button>
                            </section>

                            <section class="mt-2" name="Avatar">
                                <h4 class="text-red no-margin">
                                    CAMBIAR AVATAR
                                </h4>
                                <hr class="line" />
                                <div class="md-layout md-gutter md-alignment-top-center">
                                    <div class="md-layout-item md-small-size-33 md-size-15" v-for="avatar in avatars" v-bind:key="avatar.Id">
                                        <md-card class="md-alignment-top-center avatar-card">
                                            <md-card-content>
                                                <div class="md-layout md-alignment-top-center">
                                                    <md-avatar class="md-large">
                                                        <img :src="avatar.Path" :alt="`Avatar-${avatar.Id}`" />
                                                    </md-avatar>
                                                </div>
                                                <div class="md-layout md-alignment-top-center">
                                                    <md-radio v-model="personalInfo.avatar" class="avatar-radio" :value="avatar.name"></md-radio>
                                                </div>
                                            </md-card-content>
                                        </md-card>
                                    </div>
                                    <div class="md-layout-item ">
                                        <md-field md-inline>
                                            <label>Seleccione un archivo</label>
                                            <md-file @change="selectFile" accept=".jpg, .png," />
                                            <span class="md-error">Seleccione un archivo</span>
                                            <!-- <span class="md-helper-text">Formatos permitidos PDF, DOC, DOCX, PPT, PPTX, RTF, TXT con un peso máximo de 10mb</span> -->
                                        </md-field>
                                        <!-- <md-card>
                                            <md-avatar class="md-large">
                                                <img
                                                    src="https://vuematerial.io/assets/examples/avatar.jpg"
                                                    alt="Marcos Moura"
                                                />
                                            </md-avatar>
                                            <md-content>
                                                <md-radio
                                                    :value="false"
                                                ></md-radio>
                                            </md-content>
                                        </md-card> -->
                                    </div>
                                </div>
                                <md-button class="md-raised md-primary" @click="saveAvatar">Guardar cambio</md-button>
                            </section>

                            <section class="mt-2" name="EmailMarketing">
                                <h4 class="text-red no-margin">
                                    CONFIGURACIONES
                                </h4>
                                <hr class="line" />
                                <md-checkbox v-model="personalInfo.subscribe" class="color-primary">Deseo recibir emails</md-checkbox>
                                <br />
                                <md-button class="md-raised md-primary" @click="saveEmailSubscription">Guardar cambio</md-button>
                            </section>

                            <section class="mt-2" name="PasswordUpdate">
                                <h4 class="text-red no-margin">
                                    CAMBIAR CONTRASEÑA
                                </h4>
                                <hr class="line" />
                                <form novalidate>
                                    <md-field :class="getValidationClass('old')">
                                        <label for="old">Contraseña actual</label>
                                        <md-input v-model="resetPassword.old" type="password"></md-input>
                                        <span class="md-error">Contraseña actual requerida</span>
                                    </md-field>
                                    <md-field :class="getValidationClass('password')">
                                        <label for="password">Nueva contraseña</label>
                                        <md-input v-model="resetPassword.password" type="password"></md-input>
                                        <span class="md-error">
                                            La contraseña debe contener al menos 8 caracteres. Al menos un número, una mayúscula, una minúscula y uno
                                            de los siguientes signos (! @ # $ % ^ &amp; *)</span
                                        >
                                    </md-field>
                                    <md-field class="password-confirmation" :class="getValidationClass('password_confirmation')">
                                        <label for="password_confirmation">Confirmar nueva contraseña</label>
                                        <md-input v-model="resetPassword.password_confirmation" type="password"></md-input>
                                        <span class="md-error">Confirme su contraseña</span>
                                    </md-field>
                                    <md-button class="md-raised md-primary" @click="validatePassword">Guardar cambio</md-button>
                                </form>
                            </section>
                        </md-card-content>
                    </md-card-area>
                </md-card>
            </div>
        </div>
    </div>
</template>

<script>
import axios from 'axios';
import { validationMixin } from 'vuelidate';
import { required, email, minLength, maxLength, helpers } from 'vuelidate/lib/validators';
import NavTitle from '../../layout/NavTitle';
const alpha = helpers.regex(
    'alpha',
    /^(?=.*\d)(?=.*[\u0021-\uD83C\uDFAF\uD83C\uDFAF\u0025\u0024\u2038\uD83C\uDFAF\u002b\u003c-\u0040])(?=.*[A-Z])(?=.*[a-z])\S{8,16}$/
);
export default {
    name: 'account',
    components: { NavTitle },
    mixins: [validationMixin],
    data() {
        let now = new Date();
        return {
            title: 'Mi cuenta',
            icon: 'person',
            loading: false,
            showRating: false,
            starSize: 20,
            // endPoint: "/api/collection",
            // collections: [],
            countries: this.$root.countries,
            country: null,
            emailSubscription: 0,
            Profile: {},
            personalInfo: {
                fullname: null,
                country_id: null,
                city: undefined,
                birthdate: undefined,
                gender: null,
                description: null,
                social_snapcha: null,
                social_facebook: null,
                social_twitter: null,
                social_youtube: null,
                social_instagram: null,
                subscribe: false,
                avatar: undefined
            },
            resetPassword: {
                old: null,
                password: null,
                password_confirmation: null
            },
            currentAvatar: undefined,
            avatars: [
                {
                    Id: 1,
                    Path: require('../../assets/img/avatars/PL_ÍCONOS-62.png'),
                    name: 'PL_ÍCONOS-62.png'
                },
                {
                    Id: 2,
                    Path: require('../../assets/img/avatars/PL_ÍCONOS-63.png'),
                    name: 'PL_ÍCONOS-63.png'
                },
                {
                    Id: 3,
                    Path: require('../../assets/img/avatars/PL_ÍCONOS-64.png'),
                    name: 'PL_ÍCONOS-64.png'
                },
                {
                    Id: 4,
                    Path: require('../../assets/img/avatars/PL_ÍCONOS-65.png'),
                    name: 'PL_ÍCONOS-65.png'
                },
                {
                    Id: 5,
                    Path: require('../../assets/img/avatars/PL_ÍCONOS-66.png'),
                    name: 'PL_ÍCONOS-66.png'
                },
                {
                    Id: 6,
                    Path: require('../../assets/img/avatars/PL_ÍCONOS-67.png'),
                    name: 'PL_ÍCONOS-67.png'
                },
                {
                    Id: 7,
                    Path: require('../../assets/img/avatars/PL_ÍCONOS-68.png'),
                    name: 'PL_ÍCONOS-68.png'
                },
                {
                    Id: 8,
                    Path: require('../../assets/img/avatars/PL_ÍCONOS-69.png'),
                    name: 'PL_ÍCONOS-69.png'
                },
                {
                    Id: 9,
                    Path: require('../../assets/img/avatars/PL_ÍCONOS-70.png'),
                    name: 'PL_ÍCONOS-70.png'
                },
                {
                    Id: 10,
                    Path: require('../../assets/img/avatars/PL_ÍCONOS-71.png'),
                    name: 'PL_ÍCONOS-71.png'
                },
                {
                    Id: 11,
                    Path: require('../../assets/img/avatars/PL_ÍCONOS-72.png'),
                    name: 'PL_ÍCONOS-72.png'
                },
                {
                    Id: 12,
                    Path: require('../../assets/img/avatars/PL_ÍCONOS-73.png'),
                    name: 'PL_ÍCONOS-73.png'
                }
            ]
        };
    },
    validations: {
        resetPassword: {
            old: {
                required,
                minLength: minLength(3)
            },
            password: {
                required,
                alpha,
                minLength: minLength(8)
            },
            password_confirmation: {
                required,
                minLength: minLength(8)
            }
        }
    },
    computed: {
        user() {
            let user = undefined;

            if (this.$auth.watch && this.$auth.watch && this.$auth.watch.data) {
                user = this.$auth.watch.data;
                this.personalInfo.subscribe = user.subscribe == 1 ? true : false;
            }

            return user;
        }
    },
    methods: {
        getValidationClass(fieldName) {
            const field = this.$v.resetPassword[fieldName];

            if (field) {
                return {
                    'md-invalid': field.$invalid && field.$dirty
                };
            }
        },
        // getCollections() {
        //     axios
        //         .get(this.endPoint)
        //         .then(res => {
        //             if (res && res.data) {
        //                 this.collections = res.data.data;
        //             } else {
        //                 this.collections = [];
        //             }
        //         })
        //         .catch(error => {
        //             console.log("Error getCollections" + error);
        //         });
        // },
        SavePersonalInfo() {
            this.loading = true;
            this.personalInfo.birthdate = this.personalInfo.birthdate == null ? undefined : this.personalInfo.birthdate;
            axios
                .post('api/profile', this.personalInfo)
                .then((response) => {
                    if (response && response.data) {
                        this.getDataUser();
                        this.$root.SuccessMgs('Registro exitoso');
                    }
                })
                .catch((error) => {
                    this.$root.ErrorMgs('Error al guardar el registro');
                    console.log('Error SavePersonalInfo' + error);
                })
                .finally(() => {
                    this.loading = false;
                });
        },
        saveAvatar() {
            this.loading = true;
            let data = new FormData();
            let img = this.currentAvatar ? this.currentAvatar : this.personalInfo.avatar;
            data.append('profile_image', img);
            axios
                .post('api/profile_image', data)
                .then((response) => {
                    this.$root.SuccessMgs('Se actualizo foto de perfil');
                    this.getDataUser();
                })
                .catch((error) => {
                    this.$root.ErrorMgs('Error al actualizar foto de perfil');
                    console.log('Error saveAvatar' + error);
                })
                .finally(() => {
                    this.loading = false;
                });
        },
        saveEmailSubscription() {
            this.loading = true;
            const data = { subscribe: this.personalInfo.subscribe };

            axios
                .post('api/subscribe', data)
                .then((response) => {
                    this.$root.SuccessMgs('Se actualizo correctamente');
                    this.getDataUser();
                })
                .catch((error) => {
                    this.$root.ErrorMgs('Error al actualizar');
                    console.log('Error saveEmailSubscription' + error);
                })
                .finally(() => {
                    this.loading = false;
                });
        },
        validatePassword() {
            this.$v.$touch();

            if (!this.$v.$invalid) {
                if (this.resetPassword.password != this.resetPassword.password_confirmation) {
                    this.$root.WarnMgs('La confirmación de contraseña no coincide');
                    return;
                } else {
                    this.savePassword();
                }
            }
        },
        savePassword() {
            this.loading = true;

            axios
                .post('api/resetPassword', this.resetPassword)
                .then((response) => {
                    console.log(response);
                    if (response && response.data) {
                        this.$root.SuccessMgs('La contraseña ha sido actualizada');
                        this.$root.$auth.logout();
                    }
                })
                .catch((error) => {
                    this.$root.ErrorMgs(error.response.data.errors.old[0]);
                })
                .finally(() => {
                    this.loading = false;
                });
        },
        getDataUser() {
            this.loading = true;

            axios
                .get('/api/profile')
                .then((res) => {
                    if (res && res.data) {
                        this.Profile = res.data;
                        this.personalInfo.birthdate = this.Profile.birthdate;
                        this.personalInfo.country_id = this.Profile.country_id;
                        this.personalInfo.description = this.Profile.description;
                        this.personalInfo.fullname = this.Profile.fullname;
                        this.personalInfo.gender = this.Profile.genre;
                        this.personalInfo.social_facebook = this.Profile.social_facebook;
                        this.personalInfo.social_instagram = this.Profile.social_instagram;
                        this.personalInfo.social_twitter = this.Profile.social_twitter;
                        this.personalInfo.social_youtube = this.Profile.social_youtube;
                        this.personalInfo.social_snapcha = this.Profile.social_snapchat;
                        // this.personalInfo.subscribe = this.Profile.subscribe;
                        this.country = this.$root.getCountryName(this.Profile.country_id);
                    } else {
                        this.Profile = {};
                    }
                })
                .catch((error) => {
                    this.$root.ErrorMgs('Error al traer los datos de la cuenta');
                    console.log('Error getDataUser' + error);
                })
                .finally((res) => {
                    this.loading = false;
                });
        },
        selectFile(event) {
            // `files` is always an array because the file input may be in multiple mode
            this.currentAvatar = event.target.files[0];
        }
    },
    mounted() {
        this.getDataUser();
    }
};
</script>

<style scoped>
.avatar-card {
    box-shadow: none !important;
}

.avatar-radio {
    margin: 16px 0px !important;
}

.line {
    height: 3px;
    background: #272727;
}

.md-list-item-content {
    min-height: 0px !important;
    padding: 2px 0px !important;
}
.password-confirmation {
    margin-top: 2.4rem;
}
</style>
